com.fasterxml.jackson.databind.deser.std

## Class JsonNodeDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<JsonNode>
    - - com.fasterxml.jackson.databind.deser.std.JsonNodeDeserializer

- All Implemented Interfaces:
    Serializable

      public class JsonNodeDeserializer
      extends StdDeserializer<JsonNode>

  Deserializer that can build instances of `JsonNode` from any JSON content, using appropriate `JsonNode` type.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `JsonNodeDeserializer()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `_handleDuplicateField(String fieldName, ObjectNode objectNode, JsonNode oldValue, JsonNode newValue)` Method called when there is a duplicate value for a field.
    `protected void` | `_reportProblem(JsonParser jp, String msg)`
    `JsonNode` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Implementation that will produce types of any JSON nodes; not just one deserializer is registered to handle (in case of more specialized handler).
    `protected JsonNode` | `deserializeAny(JsonParser jp, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
    `protected ArrayNode` | `deserializeArray(JsonParser jp, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
    `protected ObjectNode` | `deserializeObject(JsonParser jp, DeserializationContext ctxt, JsonNodeFactory nodeFactory)`
    `Object` | `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `static JsonDeserializer<? extends JsonNode>` | `getDeserializer(Class<?> nodeClass)` Factory method for accessing deserializer for specific node type
    `JsonNode` | `getNullValue()` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserialize, getDelegatee, getEmptyValue, getKnownPropertyNames, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JsonNodeDeserializer

          protected JsonNodeDeserializer()

  - ### Method Detail

    - #### getDeserializer

          public static JsonDeserializer<? extends JsonNode> getDeserializer(Class<?> nodeClass)

      Factory method for accessing deserializer for specific node type

    - #### deserialize

          public JsonNode deserialize(JsonParser jp,
                             DeserializationContext ctxt)
                               throws IOException,
                                      JsonProcessingException

      Implementation that will produce types of any JSON nodes; not just one deserializer is registered to handle (in case of more specialized handler). Overridden by typed sub-classes for more thorough checking
      Specified by:
        `deserialize` in class `JsonDeserializer<JsonNode>`
      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserializer value
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser jp,
                                   DeserializationContext ctxt,
                                   TypeDeserializer typeDeserializer)
                                     throws IOException,
                                            JsonProcessingException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<JsonNode>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### getNullValue

          public JsonNode getNullValue()

      Description copied from class: `JsonDeserializer`
      Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

      Note that deserializers are allowed to call this just once and then reuse returned value; that is, method is not guaranteed to be called once for each conversion.

      Default implementation simply returns null.

      Overrides:
        `getNullValue` in class `JsonDeserializer<JsonNode>`

    - #### _reportProblem

          protected void _reportProblem(JsonParser jp,
                            String msg)
                                 throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _handleDuplicateField

          protected void _handleDuplicateField(String fieldName,
                                   ObjectNode objectNode,
                                   JsonNode oldValue,
                                   JsonNode newValue)
                                        throws JsonProcessingException

      Method called when there is a duplicate value for a field. By default we don't care, and the last value is used. Can be overridden to provide alternate handling, such as throwing an exception, or choosing different strategy for combining values or choosing which one to keep.
      Parameters:
        `fieldName` - Name of the field for which duplicate value was found
        `objectNode` - Object node that contains values
        `oldValue` - Value that existed for the object node before newValue was added
        `newValue` - Newly added value just added to the object node
      Throws:
        `JsonProcessingException`

    - #### deserializeObject

          protected final ObjectNode deserializeObject(JsonParser jp,
                                     DeserializationContext ctxt,
                                     JsonNodeFactory nodeFactory)
                                                throws IOException,
                                                       JsonProcessingException

      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeArray

          protected final ArrayNode deserializeArray(JsonParser jp,
                                   DeserializationContext ctxt,
                                   JsonNodeFactory nodeFactory)
                                              throws IOException,
                                                     JsonProcessingException

      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeAny

          protected final JsonNode deserializeAny(JsonParser jp,
                                DeserializationContext ctxt,
                                JsonNodeFactory nodeFactory)
                                           throws IOException,
                                                  JsonProcessingException

      Throws:
        `IOException`
        `JsonProcessingException`

Copyright © 2012-2013 FasterXML. All Rights Reserved.